#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <numeric>

int main( void )
{
  int n, k;
  std::cin >> n >> k;

  if (n == k)
  {
    std::cout << 1 << std::endl;
    return 0;
  }

  struct state
  {
    std::vector<int>
      up, down;
    std::vector<std::vector<int>> last;

    state( int n, int k ) : last(n - k), up(n - k, 0), down(n - k, 0)
    {
      for (int i = 0; i < n - k; i++)
        last[i].resize(i + 1, 0);
    }

    void null( void )
    {
      memset(up.data(), 0, sizeof(int) * up.size());
      memset(down.data(), 0, sizeof(int) * down.size());
      for (int i = 0; i < last.size(); i++)
        memset(last[i].data(), 0, sizeof(int) * last[i].size());
    }
  };

  state state1(n, k), state2(n, k);

  state *cur = &state1, *back = &state2;

  int res = 0;

  for (int i = 1; i < std::min(k, n - k); i++)
    back->last[i][i] = 1, back->down[i] = 1;
  for (int i = k + 1; i < n - k; i++)
    back->last[i][i] = 1, back->up[i] = 1;
  if (n != 2 * k)
    res = 1;

  for (int i = 1; i < n - k; i++)
  {
    cur->null();

    for (int j = i; j < n - k; j++)
    {
      for (int l = j + 1; l <= n - k; l++)
      {
        int
          down = (j + 1 < l - j + 2) ? 0 : (back->up[j] * std::accumulate(back->last[j].cbegin() + l - j + 1, back->last[j].cend(), 0)) % 1'000'000'007,
          up = (back->down[j] * std::accumulate(back->last[j].cbegin(), back->last[j].cbegin() + std::min(l - j, j + 1), 0)) % 1'000'000'007;

        if (l == n - k)
          res = (res + (down + up) % 1'000'000'007) % 1'000'000'007;
        else
        {
          cur->down[l] = (cur->down[l] + down) % 1'000'000'007;
          cur->up[l] = (cur->up[l] + up) % 1'000'000'007;
          cur->last[l][l - j] = (cur->last[l][l - j] + (down + up) % 1'000'000'007) % 1'000'000'007;
        }
      }
    }

    std::swap(cur, back);
  }

  std::cout << res << std::endl;

  return 0;
}