#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <numeric>

using uint = int;

int main( void )
{
  uint n, k;
  std::cin >> n >> k;

  if (n == k)
  {
    std::cout << 1 << std::endl;
    return 0;
  }

  struct state
  {
    struct info
    {
      uint up, down;
    };

    std::vector<std::vector<info>> last;

    state( uint n, uint k ) : last(n - k)
    {
      for (uint i = 0; i < n - k; i++)
        last[i].resize(i + 1, {});
    }

    void null( void )
    {
      for (uint i = 0; i < last.size(); i++)
        memset(last[i].data(), 0, sizeof(info) * last[i].size());
    }
  };

  state state1(n, k), state2(n, k);

  state *cur = &state1, *back = &state2;

  uint res = 0;

  for (uint i = 1; i < std::min(k, n - k); i++)
    back->last[i][i].down = 1;
  for (uint i = k + 1; i < n - k; i++)
    back->last[i][i].up = 1;
  if (n != 2 * k)
    res = 1;

  static auto op_down = []( uint A, const state::info &B ) -> uint
  {
    return (A + B.down) % 1'000'000'007;
  };

  static auto op_up = []( uint A, const state::info &B ) -> uint
  {
    return (A + B.up) % 1'000'000'007;
  };

  for (uint i = 1; i < n - k; i++)
  {
    cur->null();

    for (uint j = i; j < n - k; j++)
      for (uint l = j + 1; l <= n - k; l++)
      {
        uint
          down = (j + 1 < l - j + 2) ? 0 : std::accumulate(back->last[j].cbegin() + (l - j + 1), back->last[j].cend(), 0, op_up),
          up = std::accumulate(back->last[j].cbegin(), back->last[j].cbegin() + std::min(l - j, j + 1), 0, op_down);

        if (l == n - k)
          res = (res + down + up) % 1'000'000'007;
        else
        {
          cur->last[l][l - j].down = (cur->last[l][l - j].down + down) % 1'000'000'007;
          cur->last[l][l - j].up = (cur->last[l][l - j].up + up) % 1'000'000'007;
       }
      }

    std::swap(cur, back);
  }

  std::cout << res << std::endl;

  return 0;
}